## zdbsp 1.19%2B20181027%2Bdfsg.1

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

#DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -q DEB_BUILD_GNU_TYPE)
include /usr/share/dpkg/architecture.mk


%:
	dh $@

override_dh_auto_install:
	install -D obj-$(DEB_HOST_GNU_TYPE)/zdbsp debian/zdbsp/usr/bin/zdbsp
	dh_install
