=== debian/changelog ===
zdbsp (1.19+20181027+dfsg.1-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:29:17 +0100

zdbsp (1.19+20181027+dfsg.1-2) unstable; urgency=medium

  * Refinements and corrections to debian/copyright
  * Fix URI in manpage
  * Add alternative for /usr/bin/bsp and Provides: doom-node-builder,
    to substitute for (e.g.) glbsp in doom map editors (e.g. wadc)

 -- Jonathan Dowland <jmtd@debian.org>  Sun, 18 Nov 2018 19:03:48 +0000

zdbsp (1.19+20181027+dfsg.1-1) unstable; urgency=medium

  * Initial release. Closes: #889145.
  * Based on the master branch from the upstream git repository, commit
    ea4d41c589b0a0788a1083facfbcc3952cd1e2ff, 7 commits ahead of v1.19.

 -- Jonathan Dowland <jmtd@debian.org>  Tue, 13 Nov 2018 11:52:56 +0000
