=== debian/rules ===
--- 
+++ 
@@ -18,5 +18,5 @@
 	dh $@
 
 override_dh_auto_install:
-	install -D obj-$(DEB_HOST_GNU_TYPE)/zdbsp debian/zdbsp/usr/bin/zdbsp
+	install -D obj-$(DEB_BUILD_GNU_TYPE)/zdbsp debian/zdbsp/usr/bin/zdbsp
 	dh_install
